; INTERMEDIATE LANGUAGE 
; TB 1802
; 1802\rca_tiny_basic.zip\rca.asm
; APDATED TO TBEK ASM SYNTAX

STRT:	PC ":\17"	; PRINT PROMPT <DC1>
	GL		; GET LINE
	SB		; SAVE POINTER
	BE L0 		; IF EMPTY,
	BR STRT	  	; THEN START AGAIN
L0:	BN GOTO		; IF LINE NUMBER,
	IL		;   THEN INSERT LINE
	BR STRT	    	; AND START AGAIN
X1:	XQ		; ELSE EXECUTE LINE
;
; EXECUTE STATEMENT
;
GOTO:	BC GOSB, "GOTO"
	JS EXPR		; GET LINE NUMBER
XEC:	SB		; SAVE POINTERS
	RB		; FOR RUNN WITH
	BE G1 	  	; CONCATENATED INPUT
	BR G2
;
GOSB:	BC STMT, "GOSUB"
	JS EXPR
	SB
	RB
G1:	BE *
	GS
G2:	GO
;
STMT:	BC PRNT, "LET"
	BV *		; MUST BE VARIABLE NAME
	BC *, "="
LET:	JS EXPR		; GO GET EXPRESSION
	BE *		; IF STATEMENT,
	SV		;   STORE RESULT
	NX
;
PRNT:	BC SKIPIT, "PR"
	BC P0, "INT"	; IF PR OR PRINT,
P0:	BE P1
	BR P2
P1:	BC P3, ":"
P2:	J  P12
SKIPIT: J  IF
P3:	BC P4, "\""
	PQ		; QUOTE MARKS STRING
	BR P5
P4:	JS EXPR
	PN
P5:	BC P6, ","
	PT
	BR P7
P6:	BC P9, ";"
P7:	BE P8
	BR P11
P8:	BR P1
P9:	BC P10, "^"
	PC "\19"	; PRINT <DC3>=13H=^S
P10:	BE *
P12:	NL		; THEN <CR><LF>
P11:	NX
;
IF:	BC INP, "IF"
	JS EXPR
	JS RELO
	JS EXPR
	BC I1, "THEN"	; (OPTIONAL)
I1:	CP
	NX
	J  GOTO

; PROCESS INPUT STATEMENT

INP:	BC RTRN, "IN"
	BC I2, "PUT"
I2:	BV *
	SB
	BE I4
I3:	PC "? \17"	; TYPE "?" PROMPT,
			; THEN <DC1>=11H=XON=^Q
	GL		; THEN READ INPUT LINE
	BE I4 		; PROCESS IT
	BR I3 		; IF NOT ENOUGH, REPEAT
I4:	BC I5, ","	; OPTIONAL COMMA?
I5:	JS EXPR		; READ A NUMBER
	SV		; STORE IN VARIABLE
	RB		; SWAP
	BC I6, ","	; IF ANOTHER COMMA,
	BR I2 	  	; THEN PROCESS IT
I6:	BE *
	NX		;   ELSE QUIT

; PROCESS RETURN STATEMENT

RTRN:	BC END, "RET"
	BC RT1, "URN"
RT1:	BE *
	RS
	NX
;
END:	BC RUNN, "END"
	BE *
	WS
;
RUNN:	BC CLER, "RUN"
	SB
	RB
	J  X1
;
CLER:	BC LISTIT, "NEW"
	MT
;
LISTIT: BC REM, "LIST"
	BE L2
LISX:	LN 1
	LN 32767
	BR L1
L2:	JS EXPR
	JS ARG
	BE *
L1:     PC "\0\0\0\0\0\0\10\0"
			; SIX <NUL>,<LF>,<NUL>
		  	; AS A PUNCH LEADER,
	LS		; THEN LIST,
	PC "\19"	; THEN TURN PUNCH OFF
	NL		;    WITH <DC3>=XOFF=^S
	NX
;
REM:	BC DFLT, "REM"
	NX
DFLT:	BV *		; IF NO KEYWORD,
	BC *, "="	;   TRY FOR "=" (LET)
	J  LET
;
; IL SUBROUTINES
;
ARG:	BC E5, ","
	BR EXPR
E5:	DS
E3:	RT
;
EXPR:	BC E0, "-"	; IF UNARY MINUS,
	JS TERM	  	; GO PROCESS IT
	NE
	BR E1
E0:	BC E4, "+"	; IGNORE LEADING PLUS
E4:	JS TERM
E1:	BC E2, "+"	; TERMS SEPARATED BY +
	JS TERM
	AD
	BR E1
E2:	BC T2, "-"	; TERM SEPARATED BY -
	JS TERM
	SU
	BR E1
;
TERM:	JS FACT
T0:	BC T1, "*"	; FACTORS SEPARATED
		  	; BY TIMES
	JS FACT
	MP
	BR T0
T1:	BC T2, "/"
	JS FACT
	DV
	BR T0
T2:	RT
;
FACT:	BC F2, "RND("
	JS F6
	J  RR7
F2:	BC F3, "USR("	; 3 ARGUMENTS POSSIBLE
	JS EXPR		; ONE REQUIRED
	JS ARG		; 2ND OPTIONAL
	JS ARG		; 3RD OPTIONAL
	JS FUNC
	US
	RT
F3:	BV F4 		; IF A VARIABLE,
	FV		;   THEN GET IT
	RT
F4:	BN F5 		; IF A NUMBER,
	RT		;   THEN GET IT
F5:	BC *, "("	; ELSE MUST BE
		  	; AN EXPRESSION
	BR F7
F6:	JS EXPR
	DS
	BC *, ","	; ANOTHER ARGUMENT
F7:	JS EXPR
;
FUNC:	BC *, ")"	; END OF PARENTHESES?
	RT
;	
RELO:	BC RR0, "="	; CONVERT RELATIONAL
		  	; OPERATORS TO CODE
	LB 2		;   BYTE ON STACK
	RT
RR0:	BC RR1, "<>"
	BR RR2
RR1:	BC RR3, "<="
	LB 3
	RT
RR3:	BC RR4, "<"
	LB 1
	RT
RR4:	BC RR5, ">="
	LB 6
	RT
RR5:	BC RR6, "><"
RR2:	LB 5
	RT
RR6:	BC *, ">"
	LB 4
	RT
;
RR7:	SU
	NE
	LN 1		; STACK POINTER
	AD		;   FOR STORE
	LB 128
	LB 128
	FV		; SET RANDOM NUMBER
	LN 2345		; R:=R*2345+6789
	MP
	LN 6789
	AD
	NO
	SV
	LB 128		; GET IT AGAIN
	FV
	SX 3
	SX 1
	SX 2
	JS F1 		; SKIPPING
F0:	JS ABS
	DV
	MP
	SU
	JS ABS
	AD
	RT
F1:	DS
	SX 1		; PUSH TOP INTO STACK
	SX 5
	SX 1
	SX 4
	DS
	SX 1
	SX 7
	SX 1
	SX 6
	RT
ABS:	DS		; PERFORM ABS FUNCTION
	LB 6
	LN 0
	CP
	NE
	RT

; END TINY BASIC INTERMEDIATE LANGUAGE PROGRAM
