               ;INTERPRETIVE LANGUAGE OPERATION CODES

	
	LISTING off

ds7   	macro   arg
        if      strlen(arg) > 1
         db     substr(arg, 0, strlen(arg) - 1)
        endif
        if      strlen(arg) > 0
         db     charfromstr(arg, strlen(arg) - 1) | 80h
        endif
        endm


;SX n    00-07   Stack Exchange.
SX	macro	n
	db	n
	endm

;NO      08      No Operation.
NO	macro
	db	08h
	endm

;LB n    09nn    Push Literal Byte onto Stack.
LB	macro	n
	db	09h, n
	endm

;LN n    0Annnn  Push Literal Number.
LN	macro	n
	db	0ah, hi(n), lo(n)
	endm

;DS      0B      Duplicate Top Number (two bytes) on Stack.
DS	macro	
	db	0bh
	endm

;SP      0C      Stack Pop.
SP	macro	
	db	0ch
	endm

;SB      10      Save BASIC Pointer.
SB	macro	
	db	10h
	endm

;RB      11      Restore BASIC Pointer.
RB	macro	
	db	11h
	endm

;FV      12      Fetch Variable.
FV	macro	
	db	12h
	endm

;SV      13      Store Variable.
SV	macro	
	db	13h
	endm

;GS      14      GOSUB Save.
GS	macro	
	db	14h
	endm

;RS      15      Restore Saved Line.
RS	macro	
	db	15h
	endm

;GO      16      GOTO.
GO	macro	
	db	16h
	endm

;NE      17      Negate (two's complement).
NE	macro	
	db	17h
	endm

;AD      18      Add.
AD	macro	
	db	18h
	endm

;SU      19      Subtract.
SU	macro	
	db	19h
	endm

;MP      1A      Multiply.
MP	macro	
	db	1Ah
	endm

;DV      1B      Divide.
DV	macro	
	db	1Bh
	endm

;CP      1C      Compare.
CP	macro	
	db	1Ch
	endm

;NX      1D      Next BASIC Statement.
NX	macro	
	db	1Dh
	endm

;LS      1F      List The Program.
LS	macro	
	db	1Fh
	endm

;PN      20      Print Number.
PN	macro	
	db	20h
	endm

;PQ      21      Print BASIC String.
PQ	macro	
	db	21h
	endm

;PT      22      Print Tab.
PT	macro	
	db	22h
	endm

;NL      23      New Line.
NL	macro	
	db	23h
	endm

;PC "xxxx"  24xxxxxxXx   Print Literal String.
PC	macro	s
	db	24h
	ds7	s
	endm

;GL      27      Get Input Line.
GL	macro	
	db	27h
	endm

;IL      2A      Insert BASIC Line.
IL	macro	
	db	2Ah
	endm

;MT      2B      Mark the BASIC program space Empty.
MT	macro	
	db	2Bh
	endm

;XQ      2C      Execute.
XQ	macro	
	db	2Ch
	endm

;WS      2D      Stop.
WS	macro	
	db	2Dh
	endm

;US      2E      Machine Language Subroutine Call.
US	macro	
	db	2Eh
	endm

;RT      2F      IL Subroutine Return.
RT	macro	
	db	2Fh
	endm

;JS a    3000-37FF       IL Subroutine Call.
JS	macro	n
	db	hi(3000h + n - STRT)
	db	lo(3000h + n - STRT)
	endm

;J a     3800-3FFF       Jump.
J	macro	n
	db	hi(3800h + n - STRT)
	db	lo(3800h + n - STRT)
	endm

;BR a    40-7F   Relative Branch.
BR	macro	n
	if "n"="*"
	db	60h
	else
	db	60h + n - $ - 1
	endif
	endm

;BC a "xxx"   80xxxxXx-9FxxxxXx  String Match Branch.
BC	macro	n, s
	if "n"="*"
	db	80h
	else
	db	80h + n - $ - 1
	endif
	ds7	s
	endm

;BV a    A0-BF   Branch if Not Variable.
BV	macro	n
	if "n"="*"
	db	0A0h
	else
	db	0A0h + n - $ - 1
	endif
	endm

;BN a    C0-DF   Branch if Not a Number.
BN	macro	n
	if "n"="*"
	db	0C0h
	else
	db	0C0h + n - $ - 1
	endif
	endm

;BE a    E0-FF   Branch if Not Endline.
BE	macro	n
	if "n"="*"
	db	0E0h
	else
	db	0E0h + n - $ - 1
	endif
	endm

	LISTING on

